<script setup lang="ts">
import { useBillCostStore } from '@/stores/billcost'
import { ref } from 'vue'
const billcostStore = useBillCostStore()
const form = ref(false)
const loading = ref(false)

const nototal = ref(false)
const notype = ref(false)

const save = () => {
  if (!billcostStore.editedbillCost.time) {
    const currentTime = new Date()
    const formattedTime = `${currentTime.getHours().toString().padStart(2, '0')}:${currentTime
      .getMinutes()
      .toString()
      .padStart(2, '0')}:${currentTime.getSeconds().toString().padStart(2, '0')}`
    billcostStore.editedbillCost.time = formattedTime
  }
  if (!billcostStore.editedbillCost.date) {
    const currentDate = new Date()
    const formattedDate = `${currentDate.getFullYear()}-${(currentDate.getMonth() + 1)
      .toString()
      .padStart(2, '0')}-${currentDate.getDate().toString().padStart(2, '0')}`
    billcostStore.editedbillCost.date = formattedDate
  }
  if (billcostStore.editedbillCost.type.trim() !== '') {
    if (billcostStore.editedbillCost.total >= 1) {
      if (billcostStore.editedbillCost.type != 'Other') {
        billcostStore.save()
      } else if (billcostStore.editedbillCost.type === 'Other') {
        if (billcostStore.editedbillCost.other.trim() !== '') {
          billcostStore.editedbillCost.type = billcostStore.editedbillCost.other
          billcostStore.save()
        } else {
          notype.value = !notype.value
        }
      }
    } else {
      nototal.value = !nototal.value
    }
  } else {
    notype.value = !notype.value
  }
}
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="billcostStore.dialog" persistent width="500">
      <v-card>
        <v-card-title>
          <span class="text-h5">Add BILL COST</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="refform" v-model="form">
            <v-container>
              <v-row>
                <!-- <v-col cols="12" sm="12" md="12" style="padding: 0">
                  <v-text-field
                    v-model="billcostStore.editedbillCost.type"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="Type"
                  ></v-text-field>
                </v-col> -->
                <v-col cols="12" sm="12" md="12" style="padding: 0">
                  <v-combobox
                    label="Type"
                    :items="['Electricity bill', 'Water bill', 'Rent bill', 'Other']"
                    v-model="billcostStore.editedbillCost.type"
                    variant="solo-filled"
                  ></v-combobox>
                </v-col>
                <v-col cols="12" sm="12" :md="12" style="padding: 0">
                  <v-text-field
                    v-if="billcostStore.editedbillCost.type === 'Other'"
                    v-model="billcostStore.editedbillCost.other"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="Type"
                    variant="solo-filled"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" :md="12" style="padding: 0">
                  <v-text-field
                    v-model="billcostStore.editedbillCost.total"
                    :readonly="loading"
                    :rules="[(v) => !!v || 'Field is required']"
                    class="mb-2"
                    clearable
                    label="total"
                    variant="solo-filled"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="billcostStore.closeDialog()">
            Close
          </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
  <template>
    <v-dialog v-model="nototal" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning">
          <v-card-text> Please enter the amount.</v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
    <v-dialog v-model="notype" width="250">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning">
          <v-card-text> Please enter type. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>
  </template>
  <!-- <v-row>
  <v-dialog v-model="billcostStore.showValidationDialog" persistent>
    <v-card>
      <v-card-text>
        Please enter the correct amount.
      </v-card-text>
      <v-card-actions>
        <v-btn @click="billcostStore.showValidationDialog = false">OK</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
  </v-row> -->
</template>
